]> git.ipfire.org Git - thirdparty/git.git/blob - t/test-lib.sh
Merge branch 'jk/test-lsan-denoise-output' into maint-2.42
[thirdparty/git.git] / t / test-lib.sh
1 # Test framework for git. See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
24 TEST_DIRECTORY=$(pwd)
25 else
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
30 # same path.
31 #
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
35 # needing to exist.
36 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
37 fi
38 if test -z "$TEST_OUTPUT_DIRECTORY"
39 then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
43 fi
44 GIT_BUILD_DIR="${TEST_DIRECTORY%/t}"
45 if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
46 then
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
48 exit 1
49 fi
50 if test -f "$GIT_BUILD_DIR/GIT-BUILD-DIR"
51 then
52 GIT_BUILD_DIR="$(cat "$GIT_BUILD_DIR/GIT-BUILD-DIR")" || exit 1
53 # On Windows, we must convert Windows paths lest they contain a colon
54 case "$(uname -s)" in
55 *MINGW*)
56 GIT_BUILD_DIR="$(cygpath -au "$GIT_BUILD_DIR")"
57 ;;
58 esac
59 fi
60
61 # Prepend a string to a VAR using an arbitrary ":" delimiter, not
62 # adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
63 #
64 # VAR=$1${VAR:+${1:+$2}$VAR}
65 #
66 # Usage (using ":" as the $2 delimiter):
67 #
68 # prepend_var VAR : VALUE
69 prepend_var () {
70 eval "$1=\"$3\${$1:+${3:+$2}\$$1}\""
71 }
72
73 # If [AL]SAN is in effect we want to abort so that we notice
74 # problems. The GIT_SAN_OPTIONS variable can be used to set common
75 # defaults shared between [AL]SAN_OPTIONS.
76 prepend_var GIT_SAN_OPTIONS : abort_on_error=1
77 prepend_var GIT_SAN_OPTIONS : strip_path_prefix="$GIT_BUILD_DIR/"
78
79 # If we were built with ASAN, it may complain about leaks
80 # of program-lifetime variables. Disable it by default to lower
81 # the noise level. This needs to happen at the start of the script,
82 # before we even do our "did we build git yet" check (since we don't
83 # want that one to complain to stderr).
84 prepend_var ASAN_OPTIONS : $GIT_SAN_OPTIONS
85 prepend_var ASAN_OPTIONS : detect_leaks=0
86 export ASAN_OPTIONS
87
88 prepend_var LSAN_OPTIONS : $GIT_SAN_OPTIONS
89 prepend_var LSAN_OPTIONS : fast_unwind_on_malloc=0
90 export LSAN_OPTIONS
91
92 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
93 then
94 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
95 exit 1
96 fi
97 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
98 export PERL_PATH SHELL_PATH
99
100 # In t0000, we need to override test directories of nested testcases. In case
101 # the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
102 # reset this value to instead contain what the developer has specified. We thus
103 # have this knob to allow overriding the directory.
104 if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
105 then
106 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
107 fi
108
109 # Disallow the use of abbreviated options in the test suite by default
110 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
111 then
112 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
113 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
114 fi
115
116 # Explicitly set the default branch name for testing, to avoid the
117 # transitory "git init" warning under --verbose.
118 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
119 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
120
121 ################################################################
122 # It appears that people try to run tests without building...
123 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
124 if test $? != 1
125 then
126 if test -n "$GIT_TEST_INSTALLED"
127 then
128 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
129 else
130 echo >&2 'error: you do not seem to have built git yet.'
131 fi
132 exit 1
133 fi
134
135 store_arg_to=
136 opt_required_arg=
137 # $1: option string
138 # $2: name of the var where the arg will be stored
139 mark_option_requires_arg () {
140 if test -n "$opt_required_arg"
141 then
142 echo "error: options that require args cannot be bundled" \
143 "together: '$opt_required_arg' and '$1'" >&2
144 exit 1
145 fi
146 opt_required_arg=$1
147 store_arg_to=$2
148 }
149
150 # These functions can be overridden e.g. to output JUnit XML
151 start_test_output () { :; }
152 start_test_case_output () { :; }
153 finalize_test_case_output () { :; }
154 finalize_test_output () { :; }
155
156 parse_option () {
157 local opt="$1"
158
159 case "$opt" in
160 -d|--d|--de|--deb|--debu|--debug)
161 debug=t ;;
162 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
163 immediate=t ;;
164 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
165 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
166 -r)
167 mark_option_requires_arg "$opt" run_list
168 ;;
169 --run=*)
170 run_list=${opt#--*=} ;;
171 -h|--h|--he|--hel|--help)
172 help=t ;;
173 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
174 verbose=t ;;
175 --verbose-only=*)
176 verbose_only=${opt#--*=}
177 ;;
178 -q|--q|--qu|--qui|--quie|--quiet)
179 # Ignore --quiet under a TAP::Harness. Saying how many tests
180 # passed without the ok/not ok details is always an error.
181 test -z "$HARNESS_ACTIVE" && quiet=t ;;
182 --with-dashes)
183 with_dashes=t ;;
184 --no-bin-wrappers)
185 no_bin_wrappers=t ;;
186 --no-color)
187 color= ;;
188 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
189 valgrind=memcheck
190 tee=t
191 ;;
192 --valgrind=*)
193 valgrind=${opt#--*=}
194 tee=t
195 ;;
196 --valgrind-only=*)
197 valgrind_only=${opt#--*=}
198 tee=t
199 ;;
200 --tee)
201 tee=t ;;
202 --root=*)
203 root=${opt#--*=} ;;
204 --chain-lint)
205 GIT_TEST_CHAIN_LINT=1 ;;
206 --no-chain-lint)
207 GIT_TEST_CHAIN_LINT=0 ;;
208 -x)
209 trace=t ;;
210 -V|--verbose-log)
211 verbose_log=t
212 tee=t
213 ;;
214 --write-junit-xml)
215 . "$TEST_DIRECTORY/test-lib-junit.sh"
216 ;;
217 --github-workflow-markup)
218 . "$TEST_DIRECTORY/test-lib-github-workflow-markup.sh"
219 ;;
220 --stress)
221 stress=t ;;
222 --stress=*)
223 echo "error: --stress does not accept an argument: '$opt'" >&2
224 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
225 exit 1
226 ;;
227 --stress-jobs=*)
228 stress=t;
229 stress_jobs=${opt#--*=}
230 case "$stress_jobs" in
231 *[!0-9]*|0*|"")
232 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
233 exit 1
234 ;;
235 *) # Good.
236 ;;
237 esac
238 ;;
239 --stress-limit=*)
240 stress=t;
241 stress_limit=${opt#--*=}
242 case "$stress_limit" in
243 *[!0-9]*|0*|"")
244 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
245 exit 1
246 ;;
247 *) # Good.
248 ;;
249 esac
250 ;;
251 --invert-exit-code)
252 invert_exit_code=t
253 ;;
254 *)
255 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
256 esac
257 }
258
259 # Parse options while taking care to leave $@ intact, so we will still
260 # have all the original command line options when executing the test
261 # script again for '--tee' and '--verbose-log' later.
262 for opt
263 do
264 if test -n "$store_arg_to"
265 then
266 eval $store_arg_to=\$opt
267 store_arg_to=
268 opt_required_arg=
269 continue
270 fi
271
272 case "$opt" in
273 --*|-?)
274 parse_option "$opt" ;;
275 -?*)
276 # bundled short options must be fed separately to parse_option
277 opt=${opt#-}
278 while test -n "$opt"
279 do
280 extra=${opt#?}
281 this=${opt%$extra}
282 opt=$extra
283 parse_option "-$this"
284 done
285 ;;
286 *)
287 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
288 esac
289 done
290 if test -n "$store_arg_to"
291 then
292 echo "error: $opt_required_arg requires an argument" >&2
293 exit 1
294 fi
295
296 if test -n "$valgrind_only"
297 then
298 test -z "$valgrind" && valgrind=memcheck
299 test -z "$verbose" && verbose_only="$valgrind_only"
300 elif test -n "$valgrind"
301 then
302 test -z "$verbose_log" && verbose=t
303 fi
304
305 if test -n "$stress"
306 then
307 verbose=t
308 trace=t
309 immediate=t
310 fi
311
312 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
313 TEST_NAME="$(basename "$0" .sh)"
314 TEST_NUMBER="${TEST_NAME%%-*}"
315 TEST_NUMBER="${TEST_NUMBER#t}"
316 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
317 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
318 TEST_RESULTS_SAN_FILE_PFX=trace
319 TEST_RESULTS_SAN_DIR_SFX=leak
320 TEST_RESULTS_SAN_FILE=
321 TEST_RESULTS_SAN_DIR="$TEST_RESULTS_DIR/$TEST_NAME.$TEST_RESULTS_SAN_DIR_SFX"
322 TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP=
323 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
324 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
325 case "$TRASH_DIRECTORY" in
326 /*) ;; # absolute path is good
327 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
328 esac
329
330 # Utility functions using $TEST_RESULTS_* variables
331 nr_san_dir_leaks_ () {
332 # stderr piped to /dev/null because the directory may have
333 # been "rmdir"'d already.
334 find "$TEST_RESULTS_SAN_DIR" \
335 -type f \
336 -name "$TEST_RESULTS_SAN_FILE_PFX.*" 2>/dev/null |
337 xargs grep -lv "Unable to get registers from thread" |
338 wc -l
339 }
340
341 # If --stress was passed, run this test repeatedly in several parallel loops.
342 if test "$GIT_TEST_STRESS_STARTED" = "done"
343 then
344 : # Don't stress test again.
345 elif test -n "$stress"
346 then
347 if test -n "$stress_jobs"
348 then
349 job_count=$stress_jobs
350 elif test -n "$GIT_TEST_STRESS_LOAD"
351 then
352 job_count="$GIT_TEST_STRESS_LOAD"
353 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
354 test -n "$job_count"
355 then
356 job_count=$((2 * $job_count))
357 else
358 job_count=8
359 fi
360
361 mkdir -p "$TEST_RESULTS_DIR"
362 stressfail="$TEST_RESULTS_BASE.stress-failed"
363 rm -f "$stressfail"
364
365 stress_exit=0
366 trap '
367 kill $job_pids 2>/dev/null
368 wait
369 stress_exit=1
370 ' TERM INT HUP
371
372 job_pids=
373 job_nr=0
374 while test $job_nr -lt "$job_count"
375 do
376 (
377 GIT_TEST_STRESS_STARTED=done
378 GIT_TEST_STRESS_JOB_NR=$job_nr
379 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
380
381 trap '
382 kill $test_pid 2>/dev/null
383 wait
384 exit 1
385 ' TERM INT
386
387 cnt=1
388 while ! test -e "$stressfail" &&
389 { test -z "$stress_limit" ||
390 test $cnt -le $stress_limit ; }
391 do
392 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
393 test_pid=$!
394
395 if wait $test_pid
396 then
397 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
398 else
399 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
400 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
401 fi
402 cnt=$(($cnt + 1))
403 done
404 ) &
405 job_pids="$job_pids $!"
406 job_nr=$(($job_nr + 1))
407 done
408
409 wait
410
411 if test -f "$stressfail"
412 then
413 stress_exit=1
414 echo "Log(s) of failed test run(s):"
415 for failed_job_nr in $(sort -n "$stressfail")
416 do
417 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
418 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
419 done
420 rm -rf "$TRASH_DIRECTORY.stress-failed"
421 # Move the last one.
422 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
423 fi
424
425 exit $stress_exit
426 fi
427
428 # if --tee was passed, write the output not only to the terminal, but
429 # additionally to the file test-results/$BASENAME.out, too.
430 if test "$GIT_TEST_TEE_STARTED" = "done"
431 then
432 : # do not redirect again
433 elif test -n "$tee"
434 then
435 mkdir -p "$TEST_RESULTS_DIR"
436
437 # Make this filename available to the sub-process in case it is using
438 # --verbose-log.
439 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
440 export GIT_TEST_TEE_OUTPUT_FILE
441
442 # Truncate before calling "tee -a" to get rid of the results
443 # from any previous runs.
444 >"$GIT_TEST_TEE_OUTPUT_FILE"
445
446 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
447 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
448 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
449 exit
450 fi
451
452 if test -n "$trace" && test -n "$test_untraceable"
453 then
454 # '-x' tracing requested, but this test script can't be reliably
455 # traced, unless it is run with a Bash version supporting
456 # BASH_XTRACEFD (introduced in Bash v4.1).
457 #
458 # Perform this version check _after_ the test script was
459 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
460 # '--verbose-log', so the right shell is checked and the
461 # warning is issued only once.
462 if test -n "$BASH_VERSION" && eval '
463 test ${BASH_VERSINFO[0]} -gt 4 || {
464 test ${BASH_VERSINFO[0]} -eq 4 &&
465 test ${BASH_VERSINFO[1]} -ge 1
466 }
467 '
468 then
469 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
470 else
471 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
472 trace=
473 fi
474 fi
475 if test -n "$trace" && test -z "$verbose_log"
476 then
477 verbose=t
478 fi
479
480 # Since bash 5.0, checkwinsize is enabled by default which does
481 # update the COLUMNS variable every time a non-builtin command
482 # completes, even for non-interactive shells.
483 # Disable that since we are aiming for repeatability.
484 test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
485
486 # For repeatability, reset the environment to known value.
487 # TERM is sanitized below, after saving color control sequences.
488 LANG=C
489 LC_ALL=C
490 PAGER=cat
491 TZ=UTC
492 COLUMNS=80
493 export LANG LC_ALL PAGER TZ COLUMNS
494 EDITOR=:
495
496 # A call to "unset" with no arguments causes at least Solaris 10
497 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
498 # deriving from the command substitution clustered with the other
499 # ones.
500 unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
501 my @env = keys %ENV;
502 my $ok = join("|", qw(
503 TRACE
504 DEBUG
505 TEST
506 .*_TEST
507 PROVE
508 VALGRIND
509 UNZIP
510 PERF_
511 CURL_VERBOSE
512 TRACE_CURL
513 ));
514 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
515 print join("\n", @vars);
516 ')
517 unset XDG_CACHE_HOME
518 unset XDG_CONFIG_HOME
519 unset GITPERLLIB
520 unset GIT_TRACE2_PARENT_NAME
521 unset GIT_TRACE2_PARENT_SID
522 TEST_AUTHOR_LOCALNAME=author
523 TEST_AUTHOR_DOMAIN=example.com
524 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
525 GIT_AUTHOR_NAME='A U Thor'
526 GIT_AUTHOR_DATE='1112354055 +0200'
527 TEST_COMMITTER_LOCALNAME=committer
528 TEST_COMMITTER_DOMAIN=example.com
529 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
530 GIT_COMMITTER_NAME='C O Mitter'
531 GIT_COMMITTER_DATE='1112354055 +0200'
532 GIT_MERGE_VERBOSITY=5
533 GIT_MERGE_AUTOEDIT=no
534 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
535 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
536 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
537 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
538 export EDITOR
539
540 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
541 export GIT_DEFAULT_HASH
542 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
543 export GIT_TEST_MERGE_ALGORITHM
544
545 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
546 GIT_TRACE_BARE=1
547 export GIT_TRACE_BARE
548
549 # Some tests scan the GIT_TRACE2_EVENT feed for events, but the
550 # default depth is 2, which frequently causes issues when the
551 # events are wrapped in new regions. Set it to a sufficiently
552 # large depth to avoid custom changes in the test suite.
553 GIT_TRACE2_EVENT_NESTING=100
554 export GIT_TRACE2_EVENT_NESTING
555
556 # Use specific version of the index file format
557 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
558 then
559 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
560 export GIT_INDEX_VERSION
561 fi
562
563 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
564 then
565 GIT_PERL_FATAL_WARNINGS=1
566 export GIT_PERL_FATAL_WARNINGS
567 fi
568
569 case $GIT_TEST_FSYNC in
570 '')
571 GIT_TEST_FSYNC=0
572 export GIT_TEST_FSYNC
573 ;;
574 esac
575
576 # Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
577 # the test with valgrind and have not compiled with conflict SANITIZE
578 # options.
579 if test -n "$valgrind" ||
580 test -n "$SANITIZE_ADDRESS" ||
581 test -n "$SANITIZE_LEAK" ||
582 test -n "$TEST_NO_MALLOC_CHECK"
583 then
584 setup_malloc_check () {
585 : nothing
586 }
587 teardown_malloc_check () {
588 : nothing
589 }
590 else
591 _USE_GLIBC_TUNABLES=
592 if _GLIBC_VERSION=$(getconf GNU_LIBC_VERSION 2>/dev/null) &&
593 _GLIBC_VERSION=${_GLIBC_VERSION#"glibc "} &&
594 expr 2.34 \<= "$_GLIBC_VERSION" >/dev/null
595 then
596 _USE_GLIBC_TUNABLES=YesPlease
597 fi
598 setup_malloc_check () {
599 local g
600 local t
601 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
602 export MALLOC_CHECK_ MALLOC_PERTURB_
603 if test -n "$_USE_GLIBC_TUNABLES"
604 then
605 g=
606 LD_PRELOAD="libc_malloc_debug.so.0"
607 for t in \
608 glibc.malloc.check=1 \
609 glibc.malloc.perturb=165
610 do
611 g="${g#:}:$t"
612 done
613 GLIBC_TUNABLES=$g
614 export LD_PRELOAD GLIBC_TUNABLES
615 fi
616 }
617 teardown_malloc_check () {
618 unset MALLOC_CHECK_ MALLOC_PERTURB_
619 unset LD_PRELOAD GLIBC_TUNABLES
620 }
621 fi
622
623 # Protect ourselves from common misconfiguration to export
624 # CDPATH into the environment
625 unset CDPATH
626
627 unset GREP_OPTIONS
628 unset UNZIP
629
630 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
631 1|2|true)
632 GIT_TRACE=4
633 ;;
634 esac
635
636 # Line feed
637 LF='
638 '
639
640 # Single quote
641 SQ=\'
642
643 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
644 # when case-folding filenames
645 u200c=$(printf '\342\200\214')
646
647 export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
648
649 test "x$TERM" != "xdumb" && (
650 test -t 1 &&
651 tput bold >/dev/null 2>&1 &&
652 tput setaf 1 >/dev/null 2>&1 &&
653 tput sgr0 >/dev/null 2>&1
654 ) &&
655 color=t
656
657 if test -n "$color"
658 then
659 # Save the color control sequences now rather than run tput
660 # each time say_color() is called. This is done for two
661 # reasons:
662 # * TERM will be changed to dumb
663 # * HOME will be changed to a temporary directory and tput
664 # might need to read ~/.terminfo from the original HOME
665 # directory to get the control sequences
666 # Note: This approach assumes the control sequences don't end
667 # in a newline for any terminal of interest (command
668 # substitutions strip trailing newlines). Given that most
669 # (all?) terminals in common use are related to ECMA-48, this
670 # shouldn't be a problem.
671 say_color_error=$(tput bold; tput setaf 1) # bold red
672 say_color_skip=$(tput setaf 4) # blue
673 say_color_warn=$(tput setaf 3) # brown/yellow
674 say_color_pass=$(tput setaf 2) # green
675 say_color_info=$(tput setaf 6) # cyan
676 say_color_reset=$(tput sgr0)
677 say_color_="" # no formatting for normal text
678 say_color () {
679 test -z "$1" && test -n "$quiet" && return
680 eval "say_color_color=\$say_color_$1"
681 shift
682 printf "%s\\n" "$say_color_color$*$say_color_reset"
683 }
684 else
685 say_color() {
686 test -z "$1" && test -n "$quiet" && return
687 shift
688 printf "%s\n" "$*"
689 }
690 fi
691
692 USER_TERM="$TERM"
693 TERM=dumb
694 export TERM USER_TERM
695
696 # What is written by tests to stdout and stderr is sent to different places
697 # depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
698 # with --tee option, etc.). We save the original stdin to FD #6 and stdout and
699 # stderr to #5 and #7, so that the test framework can use them (e.g. for
700 # printing errors within the test framework) independently of the test mode.
701 exec 5>&1
702 exec 6<&0
703 exec 7>&2
704
705 _error_exit () {
706 finalize_test_output
707 GIT_EXIT_OK=t
708 exit 1
709 }
710
711 error () {
712 say_color error "error: $*"
713 _error_exit
714 }
715
716 BUG () {
717 error >&7 "bug in the test script: $*"
718 }
719
720 BAIL_OUT () {
721 test $# -ne 1 && BUG "1 param"
722
723 # Do not change "Bail out! " string. It's part of TAP syntax:
724 # https://testanything.org/tap-specification.html
725 local bail_out="Bail out! "
726 local message="$1"
727
728 say_color >&5 error $bail_out "$message"
729 _error_exit
730 }
731
732 say () {
733 say_color info "$*"
734 }
735
736 if test -n "$HARNESS_ACTIVE"
737 then
738 if test "$verbose" = t || test -n "$verbose_only"
739 then
740 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
741 fi
742 fi
743
744 test "${test_description}" != "" ||
745 error "Test script did not set test_description."
746
747 if test "$help" = "t"
748 then
749 printf '%s\n' "$test_description"
750 exit 0
751 fi
752
753 if test "$verbose_log" = "t"
754 then
755 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
756 elif test "$verbose" = "t"
757 then
758 exec 4>&2 3>&1
759 else
760 exec 4>/dev/null 3>/dev/null
761 fi
762
763 # Send any "-x" output directly to stderr to avoid polluting tests
764 # which capture stderr. We can do this unconditionally since it
765 # has no effect if tracing isn't turned on.
766 #
767 # Note that this sets up the trace fd as soon as we assign the variable, so it
768 # must come after the creation of descriptor 4 above. Likewise, we must never
769 # unset this, as it has the side effect of closing descriptor 4, which we
770 # use to show verbose tests to the user.
771 #
772 # Note also that we don't need or want to export it. The tracing is local to
773 # this shell, and we would not want to influence any shells we exec.
774 BASH_XTRACEFD=4
775
776 test_failure=0
777 test_count=0
778 test_fixed=0
779 test_broken=0
780 test_success=0
781
782 test_missing_prereq=
783
784 test_external_has_tap=0
785
786 die () {
787 code=$?
788 # This is responsible for running the atexit commands even when a
789 # test script run with '--immediate' fails, or when the user hits
790 # ctrl-C, i.e. when 'test_done' is not invoked at all.
791 test_atexit_handler || code=$?
792 if test -n "$GIT_EXIT_OK"
793 then
794 exit $code
795 else
796 echo >&5 "FATAL: Unexpected exit with code $code"
797 exit 1
798 fi
799 }
800
801 GIT_EXIT_OK=
802 trap 'die' EXIT
803 # Disable '-x' tracing, because with some shells, notably dash, it
804 # prevents running the cleanup commands when a test script run with
805 # '--verbose-log -x' is interrupted.
806 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
807
808 # The user-facing functions are loaded from a separate file so that
809 # test_perf subshells can have them too
810 . "$TEST_DIRECTORY/test-lib-functions.sh"
811
812 # You are not expected to call test_ok_ and test_failure_ directly, use
813 # the test_expect_* functions instead.
814
815 test_ok_ () {
816 test_success=$(($test_success + 1))
817 say_color "" "ok $test_count - $@"
818 finalize_test_case_output ok "$@"
819 }
820
821 _invert_exit_code_failure_end_blurb () {
822 say_color warn "# faked up failures as TODO & now exiting with 0 due to --invert-exit-code"
823 }
824
825 test_failure_ () {
826 failure_label=$1
827 test_failure=$(($test_failure + 1))
828 local pfx=""
829 if test -n "$invert_exit_code" # && test -n "$HARNESS_ACTIVE"
830 then
831 pfx="# TODO induced breakage (--invert-exit-code):"
832 fi
833 say_color error "not ok $test_count - ${pfx:+$pfx }$1"
834 shift
835 printf '%s\n' "$*" | sed -e 's/^/# /'
836 if test -n "$immediate"
837 then
838 say_color error "1..$test_count"
839 if test -n "$invert_exit_code"
840 then
841 finalize_test_output
842 _invert_exit_code_failure_end_blurb
843 GIT_EXIT_OK=t
844 exit 0
845 fi
846 _error_exit
847 fi
848 finalize_test_case_output failure "$failure_label" "$@"
849 }
850
851 test_known_broken_ok_ () {
852 test_fixed=$(($test_fixed+1))
853 say_color error "ok $test_count - $1 # TODO known breakage vanished"
854 finalize_test_case_output fixed "$1"
855 }
856
857 test_known_broken_failure_ () {
858 test_broken=$(($test_broken+1))
859 say_color warn "not ok $test_count - $1 # TODO known breakage"
860 finalize_test_case_output broken "$1"
861 }
862
863 test_debug () {
864 test "$debug" = "" || eval "$1"
865 }
866
867 match_pattern_list () {
868 arg="$1"
869 shift
870 test -z "$*" && return 1
871 # We need to use "$*" to get field-splitting, but we want to
872 # disable globbing, since we are matching against an arbitrary
873 # $arg, not what's in the filesystem. Using "set -f" accomplishes
874 # that, but we must do it in a subshell to avoid impacting the
875 # rest of the script. The exit value of the subshell becomes
876 # the function's return value.
877 (
878 set -f
879 for pattern_ in $*
880 do
881 case "$arg" in
882 $pattern_)
883 exit 0
884 ;;
885 esac
886 done
887 exit 1
888 )
889 }
890
891 match_test_selector_list () {
892 operation="$1"
893 shift
894 title="$1"
895 shift
896 arg="$1"
897 shift
898 test -z "$1" && return 0
899
900 # Commas are accepted as separators.
901 OLDIFS=$IFS
902 IFS=','
903 set -- $1
904 IFS=$OLDIFS
905
906 # If the first selector is negative we include by default.
907 include=
908 case "$1" in
909 !*) include=t ;;
910 esac
911
912 for selector
913 do
914 orig_selector=$selector
915
916 positive=t
917 case "$selector" in
918 !*)
919 positive=
920 selector=${selector##?}
921 ;;
922 esac
923
924 test -z "$selector" && continue
925
926 case "$selector" in
927 *-*)
928 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
929 then
930 echo "error: $operation: invalid non-numeric in range" \
931 "start: '$orig_selector'" >&2
932 exit 1
933 fi
934 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
935 then
936 echo "error: $operation: invalid non-numeric in range" \
937 "end: '$orig_selector'" >&2
938 exit 1
939 fi
940 ;;
941 *)
942 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
943 then
944 case "$title" in *${selector}*)
945 include=$positive
946 ;;
947 esac
948 continue
949 fi
950 esac
951
952 # Short cut for "obvious" cases
953 test -z "$include" && test -z "$positive" && continue
954 test -n "$include" && test -n "$positive" && continue
955
956 case "$selector" in
957 -*)
958 if test $arg -le ${selector#-}
959 then
960 include=$positive
961 fi
962 ;;
963 *-)
964 if test $arg -ge ${selector%-}
965 then
966 include=$positive
967 fi
968 ;;
969 *-*)
970 if test ${selector%%-*} -le $arg \
971 && test $arg -le ${selector#*-}
972 then
973 include=$positive
974 fi
975 ;;
976 *)
977 if test $arg -eq $selector
978 then
979 include=$positive
980 fi
981 ;;
982 esac
983 done
984
985 test -n "$include"
986 }
987
988 maybe_teardown_verbose () {
989 test -z "$verbose_only" && return
990 exec 4>/dev/null 3>/dev/null
991 verbose=
992 }
993
994 last_verbose=t
995 maybe_setup_verbose () {
996 test -z "$verbose_only" && return
997 if match_pattern_list $test_count "$verbose_only"
998 then
999 exec 4>&2 3>&1
1000 # Emit a delimiting blank line when going from
1001 # non-verbose to verbose. Within verbose mode the
1002 # delimiter is printed by test_expect_*. The choice
1003 # of the initial $last_verbose is such that before
1004 # test 1, we do not print it.
1005 test -z "$last_verbose" && echo >&3 ""
1006 verbose=t
1007 else
1008 exec 4>/dev/null 3>/dev/null
1009 verbose=
1010 fi
1011 last_verbose=$verbose
1012 }
1013
1014 maybe_teardown_valgrind () {
1015 test -z "$GIT_VALGRIND" && return
1016 GIT_VALGRIND_ENABLED=
1017 }
1018
1019 maybe_setup_valgrind () {
1020 test -z "$GIT_VALGRIND" && return
1021 if test -z "$valgrind_only"
1022 then
1023 GIT_VALGRIND_ENABLED=t
1024 return
1025 fi
1026 GIT_VALGRIND_ENABLED=
1027 if match_pattern_list $test_count "$valgrind_only"
1028 then
1029 GIT_VALGRIND_ENABLED=t
1030 fi
1031 }
1032
1033 trace_level_=0
1034 want_trace () {
1035 test "$trace" = t && {
1036 test "$verbose" = t || test "$verbose_log" = t
1037 }
1038 }
1039
1040 # This is a separate function because some tests use
1041 # "return" to end a test_expect_success block early
1042 # (and we want to make sure we run any cleanup like
1043 # "set +x").
1044 test_eval_inner_ () {
1045 eval "$*"
1046 }
1047
1048 test_eval_ () {
1049 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1050 # with non-test commands. But once in "set -x" mode, we cannot prevent
1051 # the shell from printing the "set +x" to turn it off (nor the saving
1052 # of $? before that). But we can make sure that the output goes to
1053 # /dev/null.
1054 #
1055 # There are a few subtleties here:
1056 #
1057 # - we have to redirect descriptor 4 in addition to 2, to cover
1058 # BASH_XTRACEFD
1059 #
1060 # - the actual eval has to come before the redirection block (since
1061 # it needs to see descriptor 4 to set up its stderr)
1062 #
1063 # - likewise, any error message we print must be outside the block to
1064 # access descriptor 4
1065 #
1066 # - checking $? has to come immediately after the eval, but it must
1067 # be _inside_ the block to avoid polluting the "set -x" output
1068 #
1069
1070 # Do not add anything extra (including LF) after '$*'
1071 test_eval_inner_ </dev/null >&3 2>&4 "
1072 want_trace && trace_level_=$(($trace_level_+1)) && set -x
1073 $*"
1074 {
1075 test_eval_ret_=$?
1076 if want_trace
1077 then
1078 test 1 = $trace_level_ && set +x
1079 trace_level_=$(($trace_level_-1))
1080 fi
1081 } 2>/dev/null 4>&2
1082
1083 if test "$test_eval_ret_" != 0 && want_trace
1084 then
1085 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
1086 fi
1087 return $test_eval_ret_
1088 }
1089
1090 fail_117 () {
1091 return 117
1092 }
1093
1094 test_run_ () {
1095 test_cleanup=:
1096 expecting_failure=$2
1097
1098 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
1099 # 117 is magic because it is unlikely to match the exit
1100 # code of other programs
1101 test_eval_inner_ "fail_117 && $1" </dev/null >&3 2>&4
1102 if test $? != 117
1103 then
1104 BUG "broken &&-chain: $1"
1105 fi
1106 fi
1107
1108 setup_malloc_check
1109 test_eval_ "$1"
1110 eval_ret=$?
1111 teardown_malloc_check
1112
1113 if test -z "$immediate" || test $eval_ret = 0 ||
1114 test -n "$expecting_failure" && test "$test_cleanup" != ":"
1115 then
1116 setup_malloc_check
1117 test_eval_ "$test_cleanup"
1118 teardown_malloc_check
1119 fi
1120 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1121 then
1122 echo ""
1123 fi
1124 return "$eval_ret"
1125 }
1126
1127 test_start_ () {
1128 test_count=$(($test_count+1))
1129 maybe_setup_verbose
1130 maybe_setup_valgrind
1131 start_test_case_output "$@"
1132 }
1133
1134 test_finish_ () {
1135 echo >&3 ""
1136 maybe_teardown_valgrind
1137 maybe_teardown_verbose
1138 if test -n "$GIT_TEST_TEE_OFFSET"
1139 then
1140 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1141 "$GIT_TEST_TEE_OUTPUT_FILE")
1142 fi
1143 }
1144
1145 test_skip () {
1146 to_skip=
1147 skipped_reason=
1148 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
1149 then
1150 to_skip=t
1151 skipped_reason="GIT_SKIP_TESTS"
1152 fi
1153 if test -z "$to_skip" && test -n "$run_list" &&
1154 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1155 then
1156 to_skip=t
1157 skipped_reason="--run"
1158 fi
1159 if test -z "$to_skip" && test -n "$test_prereq" &&
1160 ! test_have_prereq "$test_prereq"
1161 then
1162 to_skip=t
1163
1164 of_prereq=
1165 if test "$missing_prereq" != "$test_prereq"
1166 then
1167 of_prereq=" of $test_prereq"
1168 fi
1169 skipped_reason="missing $missing_prereq${of_prereq}"
1170
1171 # Keep a list of all the missing prereq for result aggregation
1172 if test -z "$missing_prereq"
1173 then
1174 test_missing_prereq=$missing_prereq
1175 else
1176 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1177 fi
1178 fi
1179
1180 case "$to_skip" in
1181 t)
1182
1183 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1184 : true
1185 finalize_test_case_output skip "$@"
1186 ;;
1187 *)
1188 false
1189 ;;
1190 esac
1191 }
1192
1193 # stub; perf-lib overrides it
1194 test_at_end_hook_ () {
1195 :
1196 }
1197
1198 test_atexit_cleanup=:
1199 test_atexit_handler () {
1200 # In a succeeding test script 'test_atexit_handler' is invoked
1201 # twice: first from 'test_done', then from 'die' in the trap on
1202 # EXIT.
1203 # This condition and resetting 'test_atexit_cleanup' below makes
1204 # sure that the registered cleanup commands are run only once.
1205 test : != "$test_atexit_cleanup" || return 0
1206
1207 setup_malloc_check
1208 test_eval_ "$test_atexit_cleanup"
1209 test_atexit_cleanup=:
1210 teardown_malloc_check
1211 }
1212
1213 sanitize_leak_log_message_ () {
1214 local new="$1" &&
1215 local old="$2" &&
1216 local file="$3" &&
1217
1218 printf "With SANITIZE=leak at exit we have %d leak logs, but started with %d
1219
1220 This means that we have a blindspot where git is leaking but we're
1221 losing the exit code somewhere, or not propagating it appropriately
1222 upwards!
1223
1224 See the logs at \"%s.*\";
1225 those logs are reproduced below." \
1226 "$new" "$old" "$file"
1227 }
1228
1229 check_test_results_san_file_ () {
1230 if test -z "$TEST_RESULTS_SAN_FILE"
1231 then
1232 return
1233 fi &&
1234 local old="$TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP" &&
1235 local new="$(nr_san_dir_leaks_)" &&
1236
1237 if test $new -le $old
1238 then
1239 return
1240 fi &&
1241 local out="$(sanitize_leak_log_message_ "$new" "$old" "$TEST_RESULTS_SAN_FILE")" &&
1242 say_color error "$out" &&
1243 if test "$old" != 0
1244 then
1245 echo &&
1246 say_color error "The logs include output from past runs to avoid" &&
1247 say_color error "that remove 'test-results' between runs."
1248 fi &&
1249 say_color error "$(cat "$TEST_RESULTS_SAN_FILE".*)" &&
1250
1251 if test -n "$passes_sanitize_leak" && test "$test_failure" = 0
1252 then
1253 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, exit non-zero!" &&
1254 invert_exit_code=t
1255 elif test -n "$passes_sanitize_leak"
1256 then
1257 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, and we're failing for other reasons too..." &&
1258 invert_exit_code=
1259 elif test -n "$sanitize_leak_check" && test "$test_failure" = 0
1260 then
1261 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1262 invert_exit_code=
1263 elif test -n "$sanitize_leak_check"
1264 then
1265 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1266 invert_exit_code=t
1267 else
1268 say "With GIT_TEST_SANITIZE_LEAK_LOG=true our logs revealed a memory leak, exit non-zero!" &&
1269 invert_exit_code=t
1270 fi
1271 }
1272
1273 test_done () {
1274 # Run the atexit commands _before_ the trash directory is
1275 # removed, so the commands can access pidfiles and socket files.
1276 test_atexit_handler
1277
1278 finalize_test_output
1279
1280 if test -z "$HARNESS_ACTIVE"
1281 then
1282 mkdir -p "$TEST_RESULTS_DIR"
1283
1284 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1285 total $test_count
1286 success $test_success
1287 fixed $test_fixed
1288 broken $test_broken
1289 failed $test_failure
1290 missing_prereq $test_missing_prereq
1291
1292 EOF
1293 fi
1294
1295 if test "$test_fixed" != 0
1296 then
1297 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1298 fi
1299 if test "$test_broken" != 0
1300 then
1301 say_color warn "# still have $test_broken known breakage(s)"
1302 fi
1303 if test "$test_broken" != 0 || test "$test_fixed" != 0
1304 then
1305 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1306 msg="remaining $test_remaining test(s)"
1307 else
1308 test_remaining=$test_count
1309 msg="$test_count test(s)"
1310 fi
1311 case "$test_failure" in
1312 0)
1313 if test $test_remaining -gt 0
1314 then
1315 say_color pass "# passed all $msg"
1316 fi
1317
1318 # Maybe print SKIP message
1319 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1320 case "$test_count" in
1321 0)
1322 say "1..$test_count${skip_all:+ $skip_all}"
1323 ;;
1324 *)
1325 test -z "$skip_all" ||
1326 say_color warn "$skip_all"
1327 say "1..$test_count"
1328 ;;
1329 esac
1330
1331 if test -n "$stress" && test -n "$invert_exit_code"
1332 then
1333 # We're about to move our "$TRASH_DIRECTORY"
1334 # to "$TRASH_DIRECTORY.stress-failed" if
1335 # --stress is combined with
1336 # --invert-exit-code.
1337 say "with --stress and --invert-exit-code we're not removing '$TRASH_DIRECTORY'"
1338 elif test -z "$debug" && test -n "$remove_trash"
1339 then
1340 test -d "$TRASH_DIRECTORY" ||
1341 error "Tests passed but trash directory already removed before test cleanup; aborting"
1342
1343 cd "$TRASH_DIRECTORY/.." &&
1344 rm -fr "$TRASH_DIRECTORY" || {
1345 # try again in a bit
1346 sleep 5;
1347 rm -fr "$TRASH_DIRECTORY"
1348 } ||
1349 error "Tests passed but test cleanup failed; aborting"
1350 fi
1351
1352 check_test_results_san_file_ "$test_failure"
1353
1354 if test -z "$skip_all" && test -n "$invert_exit_code"
1355 then
1356 say_color warn "# faking up non-zero exit with --invert-exit-code"
1357 GIT_EXIT_OK=t
1358 exit 1
1359 fi
1360
1361 test_at_end_hook_
1362
1363 GIT_EXIT_OK=t
1364 exit 0 ;;
1365
1366 *)
1367 say_color error "# failed $test_failure among $msg"
1368 say "1..$test_count"
1369
1370 check_test_results_san_file_ "$test_failure"
1371
1372 if test -n "$invert_exit_code"
1373 then
1374 _invert_exit_code_failure_end_blurb
1375 GIT_EXIT_OK=t
1376 exit 0
1377 fi
1378
1379 GIT_EXIT_OK=t
1380 exit 1 ;;
1381
1382 esac
1383 }
1384
1385 if test -n "$valgrind"
1386 then
1387 make_symlink () {
1388 test -h "$2" &&
1389 test "$1" = "$(readlink "$2")" || {
1390 # be super paranoid
1391 if mkdir "$2".lock
1392 then
1393 rm -f "$2" &&
1394 ln -s "$1" "$2" &&
1395 rm -r "$2".lock
1396 else
1397 while test -d "$2".lock
1398 do
1399 say "Waiting for lock on $2."
1400 sleep 1
1401 done
1402 fi
1403 }
1404 }
1405
1406 make_valgrind_symlink () {
1407 # handle only executables, unless they are shell libraries that
1408 # need to be in the exec-path.
1409 test -x "$1" ||
1410 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1411 return;
1412
1413 base=$(basename "$1")
1414 case "$base" in
1415 test-*)
1416 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1417 ;;
1418 *)
1419 symlink_target="$GIT_BUILD_DIR/$base"
1420 ;;
1421 esac
1422 # do not override scripts
1423 if test -x "$symlink_target" &&
1424 test ! -d "$symlink_target" &&
1425 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1426 then
1427 symlink_target=../valgrind.sh
1428 fi
1429 case "$base" in
1430 *.sh|*.perl)
1431 symlink_target=../unprocessed-script
1432 esac
1433 # create the link, or replace it if it is out of date
1434 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1435 }
1436
1437 # override all git executables in TEST_DIRECTORY/..
1438 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1439 mkdir -p "$GIT_VALGRIND"/bin
1440 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1441 do
1442 make_valgrind_symlink $file
1443 done
1444 # special-case the mergetools loadables
1445 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1446 OLDIFS=$IFS
1447 IFS=:
1448 for path in $PATH
1449 do
1450 ls "$path"/git-* 2> /dev/null |
1451 while read file
1452 do
1453 make_valgrind_symlink "$file"
1454 done
1455 done
1456 IFS=$OLDIFS
1457 PATH=$GIT_VALGRIND/bin:$PATH
1458 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1459 export GIT_VALGRIND
1460 GIT_VALGRIND_MODE="$valgrind"
1461 export GIT_VALGRIND_MODE
1462 GIT_VALGRIND_ENABLED=t
1463 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1464 export GIT_VALGRIND_ENABLED
1465 elif test -n "$GIT_TEST_INSTALLED"
1466 then
1467 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1468 error "Cannot run git from $GIT_TEST_INSTALLED."
1469 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1470 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1471 else # normal case, use ../bin-wrappers only unless $with_dashes:
1472 if test -n "$no_bin_wrappers"
1473 then
1474 with_dashes=t
1475 else
1476 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1477 if ! test -x "$git_bin_dir/git"
1478 then
1479 if test -z "$with_dashes"
1480 then
1481 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1482 fi
1483 with_dashes=t
1484 fi
1485 PATH="$git_bin_dir:$PATH"
1486 fi
1487 GIT_EXEC_PATH=$GIT_BUILD_DIR
1488 if test -n "$with_dashes"
1489 then
1490 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1491 fi
1492 fi
1493 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1494 GIT_CONFIG_NOSYSTEM=1
1495 GIT_ATTR_NOSYSTEM=1
1496 GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1497 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
1498
1499 if test -z "$GIT_TEST_CMP"
1500 then
1501 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1502 then
1503 GIT_TEST_CMP="$DIFF -c"
1504 else
1505 GIT_TEST_CMP="$DIFF -u"
1506 fi
1507 fi
1508
1509 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1510 export GITPERLLIB
1511 test -d "$GIT_BUILD_DIR"/templates/blt || {
1512 BAIL_OUT "You haven't built things yet, have you?"
1513 }
1514
1515 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1516 then
1517 BAIL_OUT 'You need to build test-tool; Run "make t/helper/test-tool" in the source (toplevel) directory'
1518 fi
1519
1520 # Are we running this test at all?
1521 remove_trash=
1522 this_test=${0##*/}
1523 this_test=${this_test%%-*}
1524 if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
1525 then
1526 say_color info >&3 "skipping test $this_test altogether"
1527 skip_all="skip all tests in $this_test"
1528 test_done
1529 fi
1530
1531 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK () {
1532 BAIL_OUT "$1 has no effect except when compiled with SANITIZE=leak"
1533 }
1534
1535 if test -n "$SANITIZE_LEAK"
1536 then
1537 # Normalize with test_bool_env
1538 passes_sanitize_leak=
1539
1540 # We need to see TEST_PASSES_SANITIZE_LEAK in "test-tool
1541 # env-helper" (via test_bool_env)
1542 export TEST_PASSES_SANITIZE_LEAK
1543 if test_bool_env TEST_PASSES_SANITIZE_LEAK false
1544 then
1545 passes_sanitize_leak=t
1546 fi
1547
1548 if test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check"
1549 then
1550 sanitize_leak_check=t
1551 if test -n "$invert_exit_code"
1552 then
1553 BAIL_OUT "cannot use --invert-exit-code under GIT_TEST_PASSING_SANITIZE_LEAK=check"
1554 fi
1555
1556 if test -z "$passes_sanitize_leak"
1557 then
1558 say "in GIT_TEST_PASSING_SANITIZE_LEAK=check mode, setting --invert-exit-code for TEST_PASSES_SANITIZE_LEAK != true"
1559 invert_exit_code=t
1560 fi
1561 elif test -z "$passes_sanitize_leak" &&
1562 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1563 then
1564 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1565 test_done
1566 fi
1567
1568 if test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1569 then
1570 if ! mkdir -p "$TEST_RESULTS_SAN_DIR"
1571 then
1572 BAIL_OUT "cannot create $TEST_RESULTS_SAN_DIR"
1573 fi &&
1574 TEST_RESULTS_SAN_FILE="$TEST_RESULTS_SAN_DIR/$TEST_RESULTS_SAN_FILE_PFX"
1575
1576 # In case "test-results" is left over from a previous
1577 # run: Only report if new leaks show up.
1578 TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP=$(nr_san_dir_leaks_)
1579
1580 # Don't litter *.leak dirs if there was nothing to report
1581 test_atexit "rmdir \"$TEST_RESULTS_SAN_DIR\" 2>/dev/null || :"
1582
1583 prepend_var LSAN_OPTIONS : dedup_token_length=9999
1584 prepend_var LSAN_OPTIONS : log_exe_name=1
1585 prepend_var LSAN_OPTIONS : log_path=\"$TEST_RESULTS_SAN_FILE\"
1586 export LSAN_OPTIONS
1587 fi
1588 elif test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check" ||
1589 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1590 then
1591 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK "GIT_TEST_PASSING_SANITIZE_LEAK=true"
1592 elif test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1593 then
1594 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK "GIT_TEST_SANITIZE_LEAK_LOG=true"
1595 fi
1596
1597 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0 &&
1598 test "${GIT_TEST_EXT_CHAIN_LINT:-1}" != 0
1599 then
1600 "$PERL_PATH" "$TEST_DIRECTORY/chainlint.pl" "$0" ||
1601 BUG "lint error (see '?!...!? annotations above)"
1602 fi
1603
1604 # Last-minute variable setup
1605 USER_HOME="$HOME"
1606 HOME="$TRASH_DIRECTORY"
1607 GNUPGHOME="$HOME/gnupg-home-not-used"
1608 export HOME GNUPGHOME USER_HOME
1609
1610 # "rm -rf" existing trash directory, even if a previous run left it
1611 # with bad permissions.
1612 remove_trash_directory () {
1613 dir="$1"
1614 if ! rm -rf "$dir" 2>/dev/null
1615 then
1616 chmod -R u+rwx "$dir"
1617 rm -rf "$dir"
1618 fi
1619 ! test -d "$dir"
1620 }
1621
1622 # Test repository
1623 remove_trash_directory "$TRASH_DIRECTORY" || {
1624 BAIL_OUT 'cannot prepare test area'
1625 }
1626
1627 remove_trash=t
1628 if test -z "$TEST_NO_CREATE_REPO"
1629 then
1630 git init \
1631 ${TEST_CREATE_REPO_NO_TEMPLATE:+--template=} \
1632 "$TRASH_DIRECTORY" >&3 2>&4 ||
1633 error "cannot run git init"
1634 else
1635 mkdir -p "$TRASH_DIRECTORY"
1636 fi
1637
1638 # Use -P to resolve symlinks in our working directory so that the cwd
1639 # in subprocesses like git equals our $PWD (for pathname comparisons).
1640 cd -P "$TRASH_DIRECTORY" || BAIL_OUT "cannot cd -P to \"$TRASH_DIRECTORY\""
1641
1642 start_test_output "$0"
1643
1644 # Convenience
1645 # A regexp to match 5 and 35 hexdigits
1646 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1647 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1648
1649 test_oid_init
1650
1651 ZERO_OID=$(test_oid zero)
1652 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1653 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1654 EMPTY_TREE=$(test_oid empty_tree)
1655 EMPTY_BLOB=$(test_oid empty_blob)
1656
1657 # Provide an implementation of the 'yes' utility; the upper bound
1658 # limit is there to help Windows that cannot stop this loop from
1659 # wasting cycles when the downstream stops reading, so do not be
1660 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1661 # limit the output of the yes utility", 2016-02-02)
1662 yes () {
1663 if test $# = 0
1664 then
1665 y=y
1666 else
1667 y="$*"
1668 fi
1669
1670 i=0
1671 while test $i -lt 99
1672 do
1673 echo "$y"
1674 i=$(($i+1))
1675 done
1676 }
1677
1678 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1679 # thus needs to be set up really early, and set an internal variable
1680 # for convenience so the hot test_set_prereq() codepath doesn't need
1681 # to call "test-tool env-helper" (via test_bool_env). Only do that work
1682 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1683 GIT_TEST_FAIL_PREREQS_INTERNAL=
1684 if test -n "$GIT_TEST_FAIL_PREREQS"
1685 then
1686 if test_bool_env GIT_TEST_FAIL_PREREQS false
1687 then
1688 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1689 test_set_prereq FAIL_PREREQS
1690 fi
1691 else
1692 test_lazy_prereq FAIL_PREREQS '
1693 test_bool_env GIT_TEST_FAIL_PREREQS false
1694 '
1695 fi
1696
1697 # Fix some commands on Windows, and other OS-specific things
1698 uname_s=$(uname -s)
1699 case $uname_s in
1700 *MINGW*)
1701 # Windows has its own (incompatible) sort and find
1702 sort () {
1703 /usr/bin/sort "$@"
1704 }
1705 find () {
1706 /usr/bin/find "$@"
1707 }
1708 # git sees Windows-style pwd
1709 pwd () {
1710 builtin pwd -W
1711 }
1712 # no POSIX permissions
1713 # backslashes in pathspec are converted to '/'
1714 # exec does not inherit the PID
1715 test_set_prereq MINGW
1716 test_set_prereq NATIVE_CRLF
1717 test_set_prereq SED_STRIPS_CR
1718 test_set_prereq GREP_STRIPS_CR
1719 test_set_prereq WINDOWS
1720 GIT_TEST_CMP="GIT_DIR=/dev/null git diff --no-index --ignore-cr-at-eol --"
1721 ;;
1722 *CYGWIN*)
1723 test_set_prereq POSIXPERM
1724 test_set_prereq EXECKEEPSPID
1725 test_set_prereq CYGWIN
1726 test_set_prereq SED_STRIPS_CR
1727 test_set_prereq GREP_STRIPS_CR
1728 test_set_prereq WINDOWS
1729 ;;
1730 *)
1731 test_set_prereq POSIXPERM
1732 test_set_prereq BSLASHPSPEC
1733 test_set_prereq EXECKEEPSPID
1734 ;;
1735 esac
1736
1737 # Detect arches where a few things don't work
1738 uname_m=$(uname -m)
1739 case $uname_m in
1740 parisc* | hppa*)
1741 test_set_prereq HPPA
1742 ;;
1743 esac
1744
1745 test_set_prereq REFFILES
1746
1747 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1748 test -z "$NO_CURL" && test_set_prereq LIBCURL
1749 test -z "$NO_PERL" && test_set_prereq PERL
1750 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1751 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1752 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1753 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1754 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1755 test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
1756 test -n "$GIT_VALGRIND_ENABLED" && test_set_prereq VALGRIND
1757
1758 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1759 then
1760 GIT_TEST_CHECK_CACHE_TREE=true
1761 export GIT_TEST_CHECK_CACHE_TREE
1762 fi
1763
1764 test_lazy_prereq PIPE '
1765 # test whether the filesystem supports FIFOs
1766 test_have_prereq !MINGW,!CYGWIN &&
1767 rm -f testfifo && mkfifo testfifo
1768 '
1769
1770 test_lazy_prereq SYMLINKS '
1771 # test whether the filesystem supports symbolic links
1772 ln -s x y && test -h y
1773 '
1774
1775 test_lazy_prereq SYMLINKS_WINDOWS '
1776 # test whether symbolic links are enabled on Windows
1777 test_have_prereq MINGW &&
1778 cmd //c "mklink y x" &> /dev/null && test -h y
1779 '
1780
1781 test_lazy_prereq FILEMODE '
1782 test "$(git config --bool core.filemode)" = true
1783 '
1784
1785 test_lazy_prereq CASE_INSENSITIVE_FS '
1786 echo good >CamelCase &&
1787 echo bad >camelcase &&
1788 test "$(cat CamelCase)" != good
1789 '
1790
1791 test_lazy_prereq FUNNYNAMES '
1792 test_have_prereq !MINGW &&
1793 touch -- \
1794 "FUNNYNAMES tab embedded" \
1795 "FUNNYNAMES \"quote embedded\"" \
1796 "FUNNYNAMES newline
1797 embedded" 2>/dev/null &&
1798 rm -- \
1799 "FUNNYNAMES tab embedded" \
1800 "FUNNYNAMES \"quote embedded\"" \
1801 "FUNNYNAMES newline
1802 embedded" 2>/dev/null
1803 '
1804
1805 test_lazy_prereq UTF8_NFD_TO_NFC '
1806 # check whether FS converts nfd unicode to nfc
1807 auml=$(printf "\303\244")
1808 aumlcdiar=$(printf "\141\314\210")
1809 >"$auml" &&
1810 test -f "$aumlcdiar"
1811 '
1812
1813 test_lazy_prereq AUTOIDENT '
1814 sane_unset GIT_AUTHOR_NAME &&
1815 sane_unset GIT_AUTHOR_EMAIL &&
1816 git var GIT_AUTHOR_IDENT
1817 '
1818
1819 test_lazy_prereq EXPENSIVE '
1820 test -n "$GIT_TEST_LONG"
1821 '
1822
1823 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1824 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1825 '
1826
1827 test_lazy_prereq USR_BIN_TIME '
1828 test -x /usr/bin/time
1829 '
1830
1831 test_lazy_prereq NOT_ROOT '
1832 uid=$(id -u) &&
1833 test "$uid" != 0
1834 '
1835
1836 test_lazy_prereq JGIT '
1837 jgit --version
1838 '
1839
1840 # SANITY is about "can you correctly predict what the filesystem would
1841 # do by only looking at the permission bits of the files and
1842 # directories?" A typical example of !SANITY is running the test
1843 # suite as root, where a test may expect "chmod -r file && cat file"
1844 # to fail because file is supposed to be unreadable after a successful
1845 # chmod. In an environment (i.e. combination of what filesystem is
1846 # being used and who is running the tests) that lacks SANITY, you may
1847 # be able to delete or create a file when the containing directory
1848 # doesn't have write permissions, or access a file even if the
1849 # containing directory doesn't have read or execute permissions.
1850
1851 test_lazy_prereq SANITY '
1852 mkdir SANETESTD.1 SANETESTD.2 &&
1853
1854 chmod +w SANETESTD.1 SANETESTD.2 &&
1855 >SANETESTD.1/x 2>SANETESTD.2/x &&
1856 chmod -w SANETESTD.1 &&
1857 chmod -r SANETESTD.1/x &&
1858 chmod -rx SANETESTD.2 ||
1859 BUG "cannot prepare SANETESTD"
1860
1861 ! test -r SANETESTD.1/x &&
1862 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1863 status=$?
1864
1865 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1866 rm -rf SANETESTD.1 SANETESTD.2 ||
1867 BUG "cannot clean SANETESTD"
1868 return $status
1869 '
1870
1871 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1872 GIT_UNZIP=${GIT_UNZIP:-unzip}
1873 test_lazy_prereq UNZIP '
1874 "$GIT_UNZIP" -v
1875 test $? -ne 127
1876 '
1877
1878 run_with_limited_cmdline () {
1879 (ulimit -s 128 && "$@")
1880 }
1881
1882 test_lazy_prereq CMDLINE_LIMIT '
1883 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1884 run_with_limited_cmdline true
1885 '
1886
1887 run_with_limited_stack () {
1888 (ulimit -s 128 && "$@")
1889 }
1890
1891 test_lazy_prereq ULIMIT_STACK_SIZE '
1892 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1893 run_with_limited_stack true
1894 '
1895
1896 run_with_limited_open_files () {
1897 (ulimit -n 32 && "$@")
1898 }
1899
1900 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1901 test_have_prereq !MINGW,!CYGWIN &&
1902 run_with_limited_open_files true
1903 '
1904
1905 build_option () {
1906 git version --build-options |
1907 sed -ne "s/^$1: //p"
1908 }
1909
1910 test_lazy_prereq SIZE_T_IS_64BIT '
1911 test 8 -eq "$(build_option sizeof-size_t)"
1912 '
1913
1914 test_lazy_prereq LONG_IS_64BIT '
1915 test 8 -le "$(build_option sizeof-long)"
1916 '
1917
1918 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1919 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1920
1921 test_lazy_prereq CURL '
1922 curl --version
1923 '
1924
1925 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1926 # which will not work with other hash algorithms and tests that work but don't
1927 # test anything meaningful (e.g. special values which cause short collisions).
1928 test_lazy_prereq SHA1 '
1929 case "$GIT_DEFAULT_HASH" in
1930 sha1) true ;;
1931 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1932 *) false ;;
1933 esac
1934 '
1935
1936 # Ensure that no test accidentally triggers a Git command
1937 # that runs the actual maintenance scheduler, affecting a user's
1938 # system permanently.
1939 # Tests that verify the scheduler integration must set this locally
1940 # to avoid errors.
1941 GIT_TEST_MAINT_SCHEDULER="none:exit 1"
1942
1943 # Does this platform support `git fsmonitor--daemon`
1944 #
1945 test_lazy_prereq FSMONITOR_DAEMON '
1946 git version --build-options >output &&
1947 grep "feature: fsmonitor--daemon" output
1948 '